function  [ rgEpsilon, rgDEstimatedCofEpsilon ] =DetermineCofEpsilonFromNormalizedDistances(rUnsorted)
    rSorted = sort(rUnsorted);           % this is the universe of sample points that we have
    ctDataPointsRecorded = 1;
    epsilonPrev = -1;
    ctSamplePoints = length(rSorted)

    % preallocate critical arrays for efficiency
    rgEpsilonTmp = zeros(1,ctSamplePoints);
    rgDEstimatedCofEpsilonTmp = zeros(1,ctSamplePoints);
    
    for i = 1:ctSamplePoints
        epsilon = rSorted(i) ;      % rSorted is offset 1
        if epsilon > epsilonPrev    % must be >=; only record if >
            dEstimatedCofR = i / ctSamplePoints; % i is the number of distances in the entire data set that are less than or equal to epsilon; because i is > 0 this must be > 0.  Note that this corresponds to 2/N(N-1)  * sigma sigma I(xj-xi <= r) in the camastra article
            rgEpsilonTmp(ctDataPointsRecorded) = epsilon;
            rgDEstimatedCofEpsilonTmp(ctDataPointsRecorded) = dEstimatedCofR;
            ctDataPointsRecorded = ctDataPointsRecorded + 1;
            epsilonPrev = epsilon ;
        end
    end
    
    rgEpsilon = rgEpsilonTmp(1:(ctDataPointsRecorded-1));
    rgDEstimatedCofEpsilon = rgDEstimatedCofEpsilonTmp(1:(ctDataPointsRecorded-1));
end
