function dEstimatedMax=EstimateMaxEmbeddingDistanceFromTimeSeries(aTimeSeries, ctSamplePairs, ctEmbeddingDimension)
    iDerivedDistances = 1;
    N = length(aTimeSeries); % last index 
        
    while iDerivedDistances  <= ctSamplePairs      % iDerivedDistances 1 based; if want 1, need to do at least 1 loop
        % ok, first select a random pair of points in the embedded space
        i = unidrnd(N - (ctEmbeddingDimension - 1) - 1);   % only going from 1 to N - (ctEmbeddingDimension - 1) - 1 because we can't find j if we use i=N - (ctEmbeddingDimension - 1) , 
        j = i + unidrnd(N - i - (ctEmbeddingDimension - 1)); % going from i+1 to N (i + N - i )
        % ok, now retrieve the embedded points corresponding to these
        % points in the time series
        
        v1 = [ aTimeSeries(i:i+ctEmbeddingDimension-1) ];
        v2 = [ aTimeSeries(j:j+ctEmbeddingDimension-1) ];
        
        diffVect = v1 - v2;
        rgSamples(iDerivedDistances) = sqrt(dot(diffVect, diffVect)) ;
        iDerivedDistances = iDerivedDistances + 1;
    end
   dEstimatedMax = max(rgSamples);
 end